<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.account.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class account {

//---- Account Filter Validation

    function account_filter_validate() {
//	global $pre,$phpgw ;
	
	$category = ($_GET["category"]) ? $_GET["category"] : $_POST["category"] ;
	$type = ($_GET["type"]) ? $_GET["type"] : $_POST["type"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;

	$err="" ;
	$choices = "ALL,A,L,Q,I,E" ;
	if (substr_count($choices,$category)<=0)	$err=lang("Invalid Category choice")." - $category" ;
	$choices = "ALL,A,H" ;
	if (substr_count($choices,$type)<=0)		$err=lang("Invalid Type choice")." - $type" ;
	if ($from<>"" and !is_numeric($from))		$err=lang("Invalid starting account number");
	if ($from<>"" and $from<=0)			$err=lang("Invalid starting account number");
	if ($to<>"" and !is_numeric($to))		$err=lang("Invalid ending account number");
	if ($to<>"" and $to>9999)			$err=lang("Invalid ending account number");

	return $err ;
	}

//---- Account List Link Adjustement

    function account_list_adjust() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)		$$key = $value ;
	foreach ($ckapi[params_list][dt] as $key => $value)	$$key = $value ;
	$filter = $ckapi[params_list][filter] ;
	$t = &$ckapi[objects][template] ;

	switch ($category) {
		case "A": $category = lang("Asset");			break;
		case "L": $category = lang("Liability");		break;
		case "Q": $category = lang("Equity");			break;
		case "I": $category = lang("Income") ;			break;
		case "E": $category = lang("Expense") ;			break;
		default:  $category = "Category Error";			break;
		}
	switch ($charttype) {
		case "A": $type = lang("Account - posting allowed");	break;
		case "H": $type = lang("HEADING (NO POSTING)");		break;
		default:  $type = "Charttype Error";			break;
		}
	$getstr = "id=$id&filter=$filter" ;
	$hist = ($charttype=="H") ? "" : $phpgw->link("/$app/${tran}hist.php",$getstr) ;
	$lang_hist = ($charttype=="H") ? "" : lang('History') ;

	$t->set_var(array(	'category'	=> $category ,
				'charttype'	=> $type ,
				'hist'		=> $hist ,
				'lang_hist'	=> $lang_hist		)) ;
	if ($charttype=="H")		$t->set_var('tr_color','') ;
	}

//---- Account Read

    function account_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$phpgw->db->query("SELECT * from ${pre}chart WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$dt["old$val"] = $dt[$val] ;
	return $dt ;
	}

//---- Account Detail Validation Checks

    function account_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	if ($dt[accno]=="")			$err=lang("Account Number Missing");
	if (!is_numeric($dt[accno]))		$err=lang("Account# must be numeric");
	if ($dt[accno]<>$dt[oldaccno]) {
		$phpgw->db->query("SELECT * FROM ${pre}chart WHERE accno='$dt[accno]'");
		if ($phpgw->db->num_rows()>0)	$err=lang("Account# already exists") ;
		}
	if ($dt[charttype]=='H') {
		foreach ($dt as $key=>$value)
			if (ord($key)>=ord("A") and ord($key)<=ord("Z"))
						$err=lang("HEADING account cannot have any flag on") ;
		}
	if ($dt[description]=="")		$err=lang("Account Description Missing") ;
	if (strlen($dt[description])>20)	$err=lang("Description too long") ;
	if ($err)				$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Account Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw,$pre ;

	$dt = &$ckapi[params_post][dt] ;
	$err=""; $error=lang('Error') ;
	$errmsg1 = lang("This ledger account is still listed as default") ;
	$inventory = lang('inventory'); $income = lang('income');
	$expense = lang('expense'); $account = lang('account') ;
	$invrec = lang("within a inventory parts record") ;
	$svcrec = lang("within a service record") ;
	$taxrec = lang("within a tax record") ;
	$errmsg2 = lang("This ledger account is in use within an existing") ;
	$journal = lang('journal'); $addon = lang('POS addon') ;
	$qcash = lang('POS quasi-cash record') ;
	$pyrcode = lang('Payroll Allowance/Deduction Code') ;
	$reductn = lang('Payroll Summary Level Reduction Type') ;
	$contri = lang('Payroll Company Contribution Type') ;

	$id = $dt[id] ;
	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	if ($id==$phpgw->db->f('inventory_accno_id'))	$err = "$errmsg1 $inventory $account";
	if ($id==$phpgw->db->f('income_accno_id'))	$err = "$errmsg1 $income $account" ;
	if ($id==$phpgw->db->f('expense_accno_id'))	$err = "$errmsg1 $expense $account" ;

	$sql = "SELECT * FROM ${pre}parts WHERE inventory_accno_id='$id' or " ;
	$sql.= "income_accno_id='$id' or expense_accno_id='$id'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $invrec id#".$phpgw->db->f('id') ;
		}
	$sql = "SELECT * FROM ${pre}service WHERE income_accno_id='$id' or expense_accno_id='$id'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $svcrec id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}tax WHERE chart_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $taxrec id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}acc_trans WHERE chart_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg2 $journal id#".$phpgw->db->f('trans_id') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}addon WHERE incacc_id='$id' or expacc_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg2 $addon id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}qcash WHERE posacc_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg2 $qcash id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}pyrcode WHERE chart_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg2 $pyrcode id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}reductn WHERE chart_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg2 $reductn id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}contri WHERE ac_exp='$id' or ac_liab='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg2 $contri id#".$phpgw->db->f('id') ;
		}

	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Account Detail

    function account_write() {
	global $ckapi,$phpgw ;

	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$cat_selectlist = "<OPTION value='A'>".lang('Asset')."</OPTION>" ;
	$cat_selectlist.= "<OPTION value='L'>".lang('Liability')."</OPTION>" ;
	$cat_selectlist.= "<OPTION value='Q'>".lang('Equity')."</OPTION>" ;
	$cat_selectlist.= "<OPTION value='I'>".lang('Income')."</OPTION>" ;
	$cat_selectlist.= "<OPTION value='E'>".lang('Expense')."</OPTION>" ;
	$type_selectlist = "<OPTION value='H'>".lang('HEADING (NO POSTING)')."</OPTION>" ;
	$type_selectlist.= "<OPTION value='A'>".lang('Account - posting allowed')."</OPTION>" ;

	/* ------------------- Print Account Details -------------------------------- */

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_accno',lang('Account Number'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_id',lang('Audit Id'));
	$t->set_var('lang_category',lang('Category'));
	$t->set_var('lang_type',lang('Type'));
	$t->set_var('lang_extcode',lang('Account code for external interface')) ;

	$category = $dt[category] ;
	$t->set_var('cat_selectlist',str_replace("'$category'","'$category'"." selected",$cat_selectlist)) ;
	$type = $dt[charttype] ;
	$t->set_var('type_selectlist',str_replace("'$type'","'$type'"." selected",$type_selectlist)) ;
	$link = $dt[link] ;

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('accno',$dt[accno]);
	$t->set_var('description',$dt[description]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('gifi',$dt[gifi]);

	/*----------------- Print Account Flag Details -------------------------------------- */

	$title1 = lang('Account Flag Settings :') ;
	$title2 = lang('(These settings should only be modified by an accountant fully conversant with the underlying operations of this ledger)') ;
	$t->set_var('lang_subtitle',"$title1<br>$title2") ;
	$t->set_var('lang_flag_message',lang('Flag message to be defined')) ;
	$t->set_var('lang_flag',lang('(On/Off) Flag'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_accnolist',lang('Ledger accounts with target flag set [on]')) ;

	$ar_checked = (substr_count(str_replace("AR_","",$link),"AR")>0 or $dt[AR]) ? "checked" : "" ;
	$ap_checked = (substr_count(str_replace("AP_","",$link),"AP")>0 or $dt[AP]) ? "checked" : "" ;
	$ic_checked = (substr_count(str_replace("IC_","",$link),"IC")>0 or $dt[IC]) ? "checked" : "" ;
	$py_checked = (substr_count(str_replace("PY_","",$link),"PY")>0 or $dt[PY]) ? "checked" : "" ;
	$ar_amount_checked = (substr_count($link,"AR_amount")>0 or $dt[AR_amount]) ? "checked" : "" ;
	$ar_tax_checked = (substr_count($link,"AR_tax")>0 or $dt[AR_tax]) ? "checked" : "" ;
	$ar_paid_checked = (substr_count($link,"AR_paid")>0 or $dt[AR_paid]) ? "checked" : "" ;
	$ap_amount_checked = (substr_count($link,"AP_amount")>0 or $dt[AP_amount]) ? "checked" : "" ;
	$ap_tax_checked = (substr_count($link,"AP_tax")>0 or $dt[AP_tax]) ? "checked" : "" ;
	$ap_paid_checked = (substr_count($link,"AP_paid")>0 or $dt[AP_paid]) ? "checked" : "" ;
	$ic_sale_checked = (substr_count($link,"IC_sale")>0 or $dt[IC_sale]) ? "checked" : "" ;
	$ic_cogs_checked = (substr_count($link,"IC_cogs")>0 or $dt[IC_cogs]) ? "checked" : "" ;
	$ic_income_checked = (substr_count($link,"IC_income")>0 or $dt[IC_income]) ? "checked" : "" ;
	$ic_expense_checked = (substr_count($link,"IC_expense")>0 or $dt[IC_expense]) ? "checked" : "" ;
	$ic_taxpart_checked = (substr_count($link,"IC_taxpart")>0 or $dt[IC_taxpart]) ? "checked" : "" ;
	$ic_taxservice_checked = (substr_count($link,"IC_taxservice")>0 or $dt[IC_taxservice]) ?"checked":"";
	$ct_tax_checked = (substr_count($link,"CT_tax")>0 or $dt[CT_tax]) ? "checked" : "" ;
	$sv_income_checked = (substr_count($link,"SV_income")>0 or $dt[SV_income]) ? "checked" : "" ;
	$sv_expense_checked = (substr_count($link,"SV_expense")>0 or $dt[SV_expense]) ? "checked" : "" ;
	$cs_checked = (substr_count(str_replace("CS_","",$link),"CS")>0 or $dt[CS]) ? "checked" : "" ;
	$cs_tax_checked = (substr_count($link,"CS_tax")>0 or $dt[CS_tax]) ? "checked" : "" ;
	$py_expense_checked = (substr_count($link,"PY_expense")>0 or $dt[PY_expense]) ? "checked" : "" ;
	$py_paid_checked = (substr_count($link,"PY_paid")>0 or $dt[PY_paid]) ? "checked" : "" ;

	$flag = array (	flag1	=>	'AR' ,
		flagchecked1	=>	"$ar_checked" ,
		flagmessage1	=>	lang('On = allow posting of [Dr/Cr - A/Cs Receivable] journal entry from AR'),
		flag2		=>	'AR_amount' ,
		flagchecked2	=>	"$ar_amount_checked" ,
		flagmessage2	=>	lang('On = allow posting of [Cr - Sales] journal entry from AR'),
		flag3		=>	'AR_tax' ,
		flagchecked3	=>	"$ar_tax_checked" ,
		flagmessage3	=>lang('On = allow posting of [Cr - Tax Payable] journal entry from AR'),
		flag4		=>	'AR_paid' ,
		flagchecked4	=>	"$ar_paid_checked" ,
		flagmessage4	=>lang('On = allow posting of [Dr - Bank/Cash(Receipt)] journal entry from AR') ,
		flag5		=>	'AP' ,
		flagchecked5	=>	"$ap_checked" ,
		flagmessage5	=>lang('On = allow posting of [Dr/Cr - A/Cs Payable] journal entry from AP') ,
		flag6		=>	'AP_amount' ,
		flagchecked6	=>	"$ap_amount_checked" ,
		flagmessage6	=>	lang('On = allow posting of [Dr - Purchases/Expenses] journal entry from AP') ,
		flag7		=>	'AP_tax' ,
		flagchecked7	=>	"$ap_tax_checked" ,
		flagmessage7	=>lang('On = allow posting of [Dr - Tax Recoverable] journal entry from AP') ,
		flag8		=>	'AP_paid' ,
		flagchecked8	=>	"$ap_paid_checked" ,
		flagmessage8	=>	lang('On = allow posting of [Cr - Bank/Cash(Payment)] journal entry from AP') ,
		flag9		=>	'IC' ,
		flagchecked9	=>	"$ic_checked" ,
		flagmessage9	=>lang('On = allow posting of [Dr/Cr - Inventory] journal entry from AP/AR') ,
		flag10		=>	'IC_sale' ,
		flagchecked10	=>	"$ic_sale_checked" ,
		flagmessage10	=>	lang('On = listed at Inventory Details page as Sales Account') ,
		flag11		=>	'IC_cogs' ,
		flagchecked11	=>	"$ic_cogs_checked" ,
		flagmessage11	=>	lang('On = allow posting of [Dr - COGS] journal entry from AR') ,
		flag12		=>	'SV_income' ,
		flagchecked12	=>	"$sv_income_checked" ,
		flagmessage12	=>	lang('On = listed at Service Details page as Income Account') ,
		flag13		=>	'SV_expense' ,
		flagchecked13	=>	"$sv_expense_checked" ,
		flagmessage13	=>	lang('On = listed at Service Details page as Expense Account') ,
		flag14		=>	'CS' ,
		flagchecked14	=>	"$cs_checked" ,
		flagmessage14	=>lang('On = allow posting of [Dr - (Quasi)Cash] journal entry from POS') ,
		flag15		=>	'CS_tax' ,
		flagchecked15	=>	"$cs_tax_checked" ,
		flagmessage15	=>lang('On = allow posting of [Cr - Tax Payable] journal entry from POS') ,
		flag16		=>	'PY' ,
		flagchecked16	=>	"$py_checked" ,
		flagmessage16	=>	lang('On = allow posting of [Dr/Cr - Payroll Payable] journal entry from Payroll'),
		flag17		=>	'PY_expense' ,
		flagchecked17	=>	"$py_expense_checked" ,
		flagmessage17	=>	lang('On = listed at Allowance/Deduction (Code) page as Payroll Expense Account') ,
		flag18		=>	'PY_paid' ,
		flagchecked18	=>	"$py_paid_checked" ,
		flagmessage18	=>	lang('On = allow posting of [Cr - Salary Payment] journal entry from Payroll') ,
		 ) ;

	For ($i=1;isset($flag['flag'.$i]);$i++)	{
		$pattern = $flag['flag'.$i] ;
		$t->set_var('flag',$pattern);
		$t->set_var('checked',$flag['flagchecked'.$i]);
		$select_filter = "WHERE link like '%$pattern:%' or link like '%$pattern'" ;
		$t->set_var('option_block',account_selectlist($select_filter));
		$t->set_var('msg',$flag['flagmessage'.$i]);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}

//---- Account Post Initialisation

    function account_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$op = &$ckapi[params_post][op] ;

	$dt[link] = ($dt[AR])		?	":AR" : "" ;
	$dt[link].= ($dt[AP])		?	":AP" : "" ;
	$dt[link].= ($dt[IC])		?	":IC" : "" ;
	$dt[link].= ($dt[AR_amount])	?	":AR_amount" : "" ;
	$dt[link].= ($dt[AR_tax])	?	":AR_tax" : "" ;
	$dt[link].= ($dt[AR_paid])	?	":AR_paid" : "" ;
	$dt[link].= ($dt[AP_amount])	?	":AP_amount" : "" ;
	$dt[link].= ($dt[AP_tax])	?	":AP_tax" : "" ;
	$dt[link].= ($dt[AP_paid])	?	":AP_paid" : "" ;
	$dt[link].= ($dt[IC_sale])	?	":IC_sale" : "" ;
	$dt[link].= ($dt[IC_cogs])	?	":IC_cogs" : "" ;
	$dt[link].= ($dt[IC_income])	?	":IC_income" : "" ;
	$dt[link].= ($dt[IC_expense])	?	":IC_expense" : "" ;
	$dt[link].= ($dt[IC_taxpart])	?	":IC_taxpart" : "" ;
	$dt[link].= ($dt[IC_taxservice])?	":IC_taxservice" : "" ;
	$dt[link].= ($dt[CT_tax])	?	":CT_tax" : "" ;
	$dt[link].= ($dt[SV_income])	?	":SV_income" : "" ;
	$dt[link].= ($dt[SV_expense])	?	":SV_expense" : "" ;
	$dt[link].= ($dt[CS])		?	":CS" : "" ;
	$dt[link].= ($dt[CS_tax])	?	":CS_tax" : "" ;
	$dt[link].= ($dt[PY])		?	":PY" : "" ;
	$dt[link].= ($dt[PY_expense])	?	":PY_expense" : "" ;
	$dt[link].= ($dt[PY_paid])	?	":PY_paid" : "" ;
	$dt[id] = ($dt[id]=="")		?	0 : $dt[id] ;
	$dt[gifi] = ($dt[gifi]=="")	?	0 : $dt[gifi] ;
	}

    }

?>