<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.payroll.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class payroll {

//---- Payroll List SQL Formation

    function payroll_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$sortkey = $ckapi[params][sortkey] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if (!$order)	{if ($sortkey<>"")	$order=$sortkey;	else $order=$field1;}
	if (!$sort)	$sort = "ASC" ;
	$sql =	"SELECT *,a.id from ${pre}payroll a, ${pre}employee b " ;
	$sql.=	"WHERE 1=1 $where and empid=b.id order by $order $sort" ;

	return $sql ;
	}

//---- Payroll Item Read

    function payroll_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("SELECT * FROM ${pre}payroll WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$phpgw->db->query("SELECT * FROM ${pre}pyrc_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['eaid'.$i]		=	$phpgw->db->f('pyrcodeid') ;
		$dt['qty'.$i]		=	$phpgw->db->f('qty') ;
		$dt['rate'.$i]		=	$phpgw->db->f('rate') ;
		$dt['amount'.$i]	=	$phpgw->db->f('amount') ;
		$dt['comment'.$i]	=	$phpgw->db->f('comment') ;
		$dt['chart_id'.$i]	=	$phpgw->db->f('chart_id') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}rdtn_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++)	$dt['rdtnid'.$i] = $phpgw->db->f('rdtnid') ;
	$phpgw->db->query("SELECT * FROM ${pre}cntr_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++)	$dt['cntrid'.$i] = $phpgw->db->f('cntrid') ;
	if (is_array($uniqueflds) and $op=='edit')
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- payroll Validation Checks

    function payroll_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = lang("Error") ;
	$lang_bs = lang('basesalary') ;
	$row = lang("Row") ;
	if ($dt[empid]<>$dt[oldempid]) {
		$phpgw->db->query("SELECT * FROM $table where empid='$dt[empid]'");
		if ($phpgw->db->num_rows()>0)
			$err=lang("Individual Staff Payroll Master for this employee already exists") ;
		}
	$salary = $dt[salary] ;
	$phpgw->db->query("SELECT * from ${pre}pyrcode where name='$lang_bs'");
	$phpgw->db->next_record();
	if ($salary<$phpgw->db->f('minamt'))		$err=lang("Basic Salary too low");
	if ($salary>$phpgw->db->f('maxamt'))		$err=lang("Basic Salary too high");
	if ($salary=="")				$err=lang("Basic Salary Missing");
	if ($salary<>"" and !is_numeric($salary))	$err=lang("Basic Salary must be numeric");
	if ($dt[bankac]=="")				$err=lang("Bank Account Number Missing");
	if ($dt[bankacname]=="")			$err=lang("Bank Account Name Missing");
	$pyrbs = "" ;
	For ($i=1;isset($dt['eaid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		$eaid = $dt['eaid'.$i] ;
		$qty = $dt['qty'.$i] ;
		$amt = $dt['amount'.$i] ;
		$eaid = ($eaid=="") ? 0 : $eaid ;
		$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$eaid'");
		$phpgw->db->next_record();
		if ($phpgw->db->f('name')==$lang_bs)	$pyrbs=$lang_bs ;
		if ($qty<$phpgw->db->f('minqty'))	$err=$rowi.lang("Quantity too low");
		if ($qty>$phpgw->db->f('maxqty'))	$err=$rowi.lang("Quantity too high");
		if ($amt<$phpgw->db->f('minamt'))	$err=$rowi.lang("Amount too low");
		if ($amt>$phpgw->db->f('maxamt'))	$err=$rowi.lang("Amount too high");
		if ($qty=="")				$err=$rowi.lang("Quantity Missing");
		if ($qty<>"" and !is_numeric($qty))	$err=$rowi.lang("Quantity must be numeric");
		if ($amt=="")				$err=$rowi.lang("Amount Missing");
		if ($amt<>"" and !is_numeric($amt))	$err=$rowi.lang("Amount must be numeric");
		if ($phpgw->db->f('single')=="y") {
			For ($j=1;isset($dt['eaid'.$j]);$j++) {
				$rowj = "[$row $j]" ;
				if ($dt['eaid'.$i]==$dt['eaid'.$j] and $i<>$j)
					$err=$rowi.$rowj.lang("Duplicative Allowance/Deduction");
				}
			}
		}
	if ($dt[salary]>0 and $pyrbs=='')		$err=lang("Recurring (basesalary) Missing") ;
	For ($i=1;isset($dt['rdtnid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		For ($j=1;isset($dt['rdtnid'.$j]);$j++) {
			$rowj = "[$row $j]" ;
			if ($dt['rdtnid'.$i]==$dt['rdtnid'.$j] and $i<>$j)
				$err=$rowi.$rowj.lang("Duplicative Reduction");
			}
		}
	For ($i=1;isset($dt['cntrid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		For ($j=1;isset($dt['cntrid'.$j]);$j++) {
			$rowj = "[$row $j]" ;
			if ($dt['cntrid'.$i]==$dt['cntrid'.$j] and $i<>$j)
				$err=$rowi.$rowj.lang("Duplicative Contribution");
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write payroll Header

    function payroll_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $phpgw->db->f('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	$t->set_var('lang_empid',lang('Employee'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_salary',lang('Basic Salary'));
	$t->set_var('lang_period',lang('Pay Period'));
	$t->set_var('lang_daypay',lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',lang('Imputed Hourly Pay'));
	$t->set_var('lang_account',lang('Payroll Liability Account'));
	$t->set_var('lang_bankac',lang('Bank A/C#'));
	$t->set_var('lang_bankacname',lang('Bank Account Name'));
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$where = (!$uniwhere) ? " WHERE id='$dt[empid]' " : $uniwhere;
	$t->set_var('employee_selectlist',employee_selectlist($where,$dt[empid])) ;
	$t->set_var('oldempid',$dt[oldempid]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('salary',$dt[salary]) ;
	$t->set_var('period_selectlist',pperiod_selectlist('',$dt[period])) ;
	$t->set_var('daypay',$dt[daypay]) ;
	$t->set_var('hourpay',$dt[hourpay]) ;
	$account_sl = account_selectlist("WHERE link like '%PY:%' or link like '%PY'",$dt[chart_id]) ;
	$t->set_var('account_selectlist',$account_sl) ;
	$t->set_var('bankac',$dt[bankac]) ;
	$t->set_var('bankacname',$dt[bankacname]) ;
	$t->parse('out','report',True);
	}

//---- Write payroll Detail

    function payroll_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_block('report','rdtn','rdtn_section');
	$t->set_block('report','cntr','cntr_section');

	$row_ = lang('Row')." " ;
	$rdrow_ = lang('rdRow')." " ;
	$ctrow_ = lang('ctRow')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_eaid',lang("Recurring Allowance/Deduction"));
	$t->set_var('lang_basis',lang("Basis of Calculation"));
	$t->set_var('lang_qty',lang("Quantity"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_unitamt',lang("Unit Amount"));
	$t->set_var('lang_rate',lang("Pay Rate"));
	$t->set_var('lang_amount',lang("Amount"));
	$t->set_var('lang_comment',lang("Comment"));
	$t->set_var('lang_chartid',lang("Payroll Expense Account") );
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('lang_reductn',lang("Summary Level Reduction"));
	$t->set_var('lang_rdtnid',lang("Reduction"));
	$t->set_var('lang_contri',lang("Company Contribution"));
	$t->set_var('lang_cntrid',lang("Contribution Type"));

	$eaid_sl = "<OPTION value=''></OPTION>".eaid_selectlist('','','short') ;
	$account_sl = account_selectlist("WHERE link like '%PY_expense%'",'') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	$tot_amount = 0 ;
	For ($i=1;isset($dt['eaid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('eaid_fld','eaid'.$i) ;
			$t->set_var('basis_fld','basis'.$i) ;
			$t->set_var('qty_fld','qty'.$i) ;
			$t->set_var('unit_fld','unit'.$i) ;
			$t->set_var('unitamt_fld','unitamt'.$i) ;
			$t->set_var('rate_fld','rate'.$i) ;
			$t->set_var('amount_fld','amount'.$i) ;
			$t->set_var('comment_fld','comment'.$i) ;
			$t->set_var('chart_id_fld','chart_id'.$i) ;
			$t->set_var('eaid_selectlist',$eaid_sl) ;
			$t->set_var('basis','') ;
			$t->set_var('qty','') ;
			$t->set_var('unit','') ;
			$t->set_var('unitamt','') ;
			$t->set_var('rate','') ;
			$t->set_var('amount','') ;
			$t->set_var('comment','') ;
			$t->set_var('chart_id_selectlist',$account_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$qty = 1 ;
		$eaid	=	($dt['eaid'.$i]=="") ? 0 : $dt['eaid'.$i] ;
		$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$eaid'");
		$phpgw->db->next_record();
		$basis		=	$phpgw->db->f('basis') ;
		$unit		=	$phpgw->db->f('unit') ;
		$unitamt	=	(substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
		$rate		=	$phpgw->db->f('rate') ;
		$chart_id	=	($dt['rate'.$i]==0) ? $phpgw->db->f('chart_id') : $dt['chart_id'.$i] ;

		if (substr_count($basis,'qty')>0)	{$qty = $dt['qty'.$i]; $t->set_var('qty_readonly','');}
			else				$t->set_var('qty_readonly','readonly') ;
		if (substr_count($basis,'bs')>0)	$unitamt = $dt[salary] ;
		if (substr_count($basis,'hp')>0)	$unitamt = $dt[hourpay] ;
		if (substr_count($basis,'dp')>0)	$unitamt = $dt[daypay] ;
		$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
		if (substr_count($basis,'amt')>0)	{$amount=$dt['amount'.$i]; $t->set_var('amt_readonly','');}
			else				$t->set_var('amt_readonly','readonly') ;
		$t->set_var('eaid_fld','eaid'.$j) ;
		$t->set_var('basis_fld','basis'.$j) ;
		$t->set_var('qty_fld','qty'.$j) ;
		$t->set_var('unit_fld','unit'.$j) ;
		$t->set_var('unitamt_fld','unitamt'.$j) ;
		$t->set_var('rate_fld','rate'.$j) ;
		$t->set_var('amount_fld','amount'.$j) ;
		$t->set_var('comment_fld','comment'.$j) ;
		$t->set_var('chart_id_fld','chart_id'.$j) ;
		$t->set_var('eaid_selectlist',str_replace("'$eaid'","'$eaid' selected",$eaid_sl)) ;
		$t->set_var('basis',$basis) ;
		$t->set_var('qty',$qty) ;
		$t->set_var('unit',$unit) ;
		$t->set_var('unitamt',$unitamt) ;
		$t->set_var('rate',$rate) ;
		$t->set_var('amount',$amount) ;
		$dt['qty'.$j] = $qty ;
		$dt['amount'.$j] = $amount ;
		$t->set_var('comment',lang('recurring')) ;
		$t->set_var('chart_id_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$account_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done");  else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done");  else $t->set_var('delrowno',$row_.$j);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		$tot_amount += $amount ;
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow==lang('Add New Recurring Allowance/Deduction Row')) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('eaid_fld','eaid'.$i) ;
		$t->set_var('basis_fld','basis'.$i) ;
		$t->set_var('qty_fld','qty'.$i) ;
		$t->set_var('unit_fld','unit'.$i) ;
		$t->set_var('unitamt_fld','unitamt'.$i) ;
		$t->set_var('rate_fld','rate'.$i) ;
		$t->set_var('amount_fld','amount'.$i) ;
		$t->set_var('comment_fld','comment'.$i) ;
		$t->set_var('chart_id_fld','chart_id'.$i) ;
		$t->set_var('eaid_selectlist',$eaid_sl) ;
		$t->set_var('basis','') ;
		$t->set_var('qty','') ;
		$t->set_var('unit','') ;
		$t->set_var('unitamt','') ;
		$t->set_var('rate','') ;
		$t->set_var('amount','') ;
		$t->set_var('comment','') ;
		$t->set_var('chart_id_selectlist',$account_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('tot_amount',$tot_amount) ;

	$rdtnid_sl = rdtnid_selectlist('','','short') ;
	if (isset($delete))	$delrowno = intval(str_replace($rdrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt['rdtnid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		$j = $i ;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('rdtnid_fld','rdtnid'.$j) ;
		$rdtnid = $dt['rdtnid'.$i] ;
		$t->set_var('rdtnid_selectlist',str_replace("'$rdtnid'","'$rdtnid' selected",$rdtnid_sl)) ;

		if ($posted)	$t->set_var('rddelrowno',"done") ;
			else	$t->set_var('rddelrowno',$rdrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('rdtn_section','rdtn', True);
		}
	if ($i==1)			$t->set_var('rdtn_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('rdtn_section','') ;
	if ($newrow==lang('Add New Reduction Row')) {
		$t->set_var('rdtnid_fld','rdtnid'.$i) ;
		$t->set_var('rdtnid_selectlist',$rdtnid_sl) ;
		$t->set_var('rddelrowno',$rdrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('rdtn_section','rdtn', True);
		}

	$cntrid_sl = cntrid_selectlist('','','short') ;
	if (isset($delete))	$delrowno = intval(str_replace($ctrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt['cntrid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		$j = $i ;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('cntrid_fld','cntrid'.$j) ;
		$cntrid = $dt['cntrid'.$i] ;
		$t->set_var('cntrid_selectlist',str_replace("'$cntrid'","'$cntrid' selected",$cntrid_sl)) ;

		if ($posted)	$t->set_var('ctdelrowno',"done") ;
			else	$t->set_var('ctdelrowno',$ctrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('cntr_section','cntr', True);
		}
	if ($i==1)			$t->set_var('cntr_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('cntr_section','') ;
	if ($newrow==lang('Add New Contribution Row')) {
		$t->set_var('cntrid_fld','cntrid'.$i) ;
		$t->set_var('cntrid_selectlist',$cntrid_sl) ;
		$t->set_var('ctdelrowno',$ctrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('cntr_section','cntr', True);
		}

	$t->parse('out','report',True);
	}

//---- Payroll Post - PreCommit Routine

    function payroll_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new') {
		$phpgw->db->query("DELETE from ${pre}pyrc_trans where pyroid='$id'");
		$phpgw->db->query("DELETE from ${pre}rdtn_trans where pyroid='$id'");
		$phpgw->db->query("DELETE from ${pre}cntr_trans where pyroid='$id'");
		}
	if ($op<>'delete') {
		For ($i=1;isset($dt['eaid'.$i]);$i++) {
			$eaid		=	$dt['eaid'.$i];
			$qty		=	$dt['qty'.$i] ;
			$unit		=	$dt['unit'.$i] ;
			$unitamt	=	$dt['unitamt'.$i] ;
			$rate		=	$dt['rate'.$i] ;
			$amount		=	$dt['amount'.$i] ;
			$comment	=	$dt['comment'.$i] ;
			$chart_id	=	$dt['chart_id'.$i] ;
			$sql = "INSERT INTO ${pre}pyrc_trans (pyroid,pyrcodeid,qty,unit,unitamt," ;
			$sql.= 				"rate,amount,comment,chart_id)";
			$sql.=	"VALUES ('$id','$eaid','$qty','$unit','$unitamt'," ;
			$sql.=				"'$rate','$amount','$comment','$chart_id')" ;
			$phpgw->db->query($sql);
			}
		For ($i=1;isset($dt['rdtnid'.$i]);$i++) {
			$rdtnid		=	$dt['rdtnid'.$i];
			$sql = "INSERT INTO ${pre}rdtn_trans (pyroid,rdtnid) VALUES ('$id','$rdtnid')";
			$phpgw->db->query($sql);
			}
		For ($i=1;isset($dt['cntrid'.$i]);$i++) {
			$cntrid		=	$dt['cntrid'.$i];
			$sql = "INSERT INTO ${pre}cntr_trans (pyroid,cntrid) VALUES ('$id','$cntrid')";
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>


