<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.pyrcode.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class pyrcode {

//---- Allowance/Deduction Code Read

    function pyrcode_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$phpgw->db->query("SELECT * from $table WHERE id='$id'");
	$phpgw->db->next_record();
	if (!is_array($uniqueflds) or $op<>'edit')    return $phpgw->db->Record;
	  else  {
		$dt = $phpgw->db->Record ;
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
		return $dt ;
		}
	}

//---- Allowance/Deduction Code Detail Validation Checks

    function pyrcode_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	global $phpgw ;

	$err=""; $error=lang('Error') ;
	if ($dt[name]=="")		$err=lang('Allowance/Deduction Code Name Missing');
	if ($dt[name]=="basesalary")	$err=lang('Basic Salary should not be deleted') ;
	if (strlen($dt[name])>10)	$err=lang('Allowance/Deduction Code Name too long (must be <=10)');
	if ($dt[description]=="")	$err=lang('Allowance/Deduction Code Description Missing');
	if (strlen($dt[description])>50)
		$err=lang('Allowance/Deduction Code Description too long (must be <=50)');

	$basis = $dt[basis] ;
	if (substr_count($basis,'qty')>0) {
		if (!is_numeric($dt[minqty]))	$err=lang('Min Quantity must be numeric');
		if (!is_numeric($dt[maxqty]))	$err=lang('Max Quantity must be numeric');
		if ($dt[minqty]>$dt[maxqty])	$err=lang('Min Quantity must not > Max Quantity') ;
		}
	if (substr_count($basis,'amt')>0) {
		if (!is_numeric($dt[minamt]))	$err=lang('Min Amount must be numeric');
		if (!is_numeric($dt[maxamt]))	$err=lang('Max Amount must be numeric');
		if ($dt[minamt]>$dt[maxamt])	$err=lang('Min Amount must not > Max Amount') ;
		}
	if (substr_count($basis,'pc')>0)
		if (!is_numeric($dt[unitamt]))	$err=lang('Unit Amount must be numeric');
	if (!is_numeric($dt[rate]))	$err=lang('Pay Rate must be numeric');
	if ($dt[rate]==0)		$err=lang('Pay Rate cannot be zero');
	if ($dt[rate]=='')		$err=lang('Pay Rate Missing');
	if ($dt[name]<>$dt[oldname]) {
		$phpgw->db->query("SELECT * FROM ${pre}pyrcode where name='$dt[name]'");
		if ($phpgw->db->num_rows()>0)	$err=lang("Allowance/Deduction Code already exists") ;
		}
	if ($err)			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Allowance/Deduction Code Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$id = $dt[id] ;
	$errmsg1 = lang("This allowance/deduction code is in use within an existing") ;
	$recurpayroll = lang("recurring allowance/deduction record of employee") ;
	$sql = "SELECT empid FROM ${pre}pyrc_trans a,${pre}payroll b " ;
	$sql.= "WHERE pyrcodeid='$id' and a.pyroid=b.id" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $recurpayroll id#".$phpgw->db->f('empid') ;
		}
	$pynr_tran = lang("non-recurring payroll item record") ;
	$phpgw->db->query("SELECT * FROM ${pre}pynr_trans WHERE pyrcodeid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $pynr_tran id#".$phpgw->db->f('id') ;
		}
	$allow = $dt[allowdelete] ;
	if ($allow<>"y" and $allow<>"Y")  $err=lang("Allowance/Deduction code flagged deletion not allowed");

	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Allowance/Deduction Code Detail

    function pyrcode_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$noyes_sl = "<OPTION value='n'>".lang('No')."</OPTION><OPTION value='y'>".lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_name',lang('Code Name (10 char max)'));
	$t->set_var('lang_description',lang('Description (50 char max)'));
	$t->set_var('lang_basis',lang('Basis of Calculation'));
	$t->set_var('lang_minqty',lang('Minimum Quantity'));
	$t->set_var('lang_maxqty',lang('Maximum Quantity'));
	$t->set_var('lang_minamt',lang('Minimum Amount'));
	$t->set_var('lang_maxamt',lang('Maximum Amount'));
	$t->set_var('lang_unitamt',lang('Unit Amount'));
	$t->set_var('lang_unit',lang('Unit Measure'));
	$t->set_var('lang_rate',lang('Pay Rate (should normally be one)'));
	$t->set_var('lang_chart_id',lang('Payroll Expense Account'));
	$t->set_var('lang_single',lang('One item per Payroll'));
	$t->set_var('lang_allowssc',lang('Allow Staff Self Claim'));
	$t->set_var('lang_adelete',lang('Allow Delete'));
	$id = $dt[id] ;
	$basis = $dt[basis] ;
	$t->set_var('id',$id);
	$t->set_var('control',$dt[control]);
	$t->set_var('name',$dt[name]);
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('description',$dt[description]);
	$t->set_var('basis_selectlist',basis_selectlist('',$basis));
	$t->set_var('minqty',$dt[minqty]);
	$t->set_var('maxqty',$dt[maxqty]);
	if (substr_count($basis,'qty')>0)	$t->set_var('qty_readonly','');
			else			$t->set_var('qty_readonly','readonly') ;
	$t->set_var('minamt',$dt[minamt]);
	$t->set_var('maxamt',$dt[maxamt]);
	if (substr_count($basis,'amt')>0)	$t->set_var('amt_readonly','');
		else				$t->set_var('amt_readonly','readonly') ;
	$t->set_var('unitamt',$dt[unitamt]);
	if (substr_count($basis,'pc')>0)	$t->set_var('unitamt_readonly','');
		else				$t->set_var('unitamt_readonly','readonly') ;
	$t->set_var('unit',$dt[unit]);
	$t->set_var('rate',$dt[rate]);
	$pyexac_sl = account_selectlist("WHERE link like '%PY_expense%'",$dt[chart_id]) ;
	$t->set_var('pyexac_selectlist',$pyexac_sl);
	$ad_sl = str_replace("'$dt[allowdelete]'","'$dt[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$single_sl = str_replace("'$dt[single]'","'$dt[single]' selected",$noyes_sl) ;
	$t->set_var('single_selectlist',$single_sl);
	$allowssc_sl = str_replace("'$dt[allowssc]'","'$dt[allowssc]' selected",$noyes_sl) ;
	$t->set_var('allowssc_selectlist',$allowssc_sl);

	$t->parse('out','report',True);
	}

    }

?>
