<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.csnt.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class csnt {

//---- Cash Sale List SQL Formation

    function csnt_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$sql =  "SELECT transdate,a.shift as shift,b.name as cashbox," ;
	$sql.=		"posnumber,a.cashier as cashier,amount,a.id as id " ;
	$sql.=  "FROM ${pre}pos a, ${pre}cashbox b " ;
	$sql.=	"WHERE amount=netamount $where AND a.cboxid=b.id ORDER BY $order $sort" ;
	return $sql ;
	}

//---- Cash Sale Data Read

    function csnt_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;
	$script = $ckapi[params_post][script] ;

	$phpgw->db->query("SELECT * FROM ${pre}pos WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	if ($op=='add' or $op=='copy') {
		$dt[cashier] = $ckapi[hostsys][username];
		unset($dt[cboxid]) ;
		unset($dt[shift]) ;
		$dt[posnumber] = "[to be assigned]" ;
		}

	$sql = "SELECT * FROM ${pre}positem " ;
	$sql.= "WHERE trans_id='$id' and (itemtype='i' or itemtype='s') ORDER BY id" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['csitemid'.$i]	=	$phpgw->db->f('itemid') ;
		$dt['csitemtype'.$i]	=	$phpgw->db->f('itemtype') ;
		$dt['csqty'.$i]		=	$phpgw->db->f('qty') ;
		$dt['csunit'.$i]	=	$phpgw->db->f('unit') ;
		$dt['csprice'.$i]	=	$phpgw->db->f('price') ;
		$dt['csdiscount'.$i]	=	$phpgw->db->f('discount') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}positem WHERE trans_id='$id' and itemtype='a' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++)	$dt['aoitemid'.$i] = $phpgw->db->f('itemid') ;

	$phpgw->db->query("SELECT * FROM ${pre}positem WHERE trans_id='$id' and itemtype='q' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['qcitemid'.$i]	=	$phpgw->db->f('itemid') ;
		$dt['qcqty'.$i]		=	$phpgw->db->f('qty') ;
		$dt['qcvalue'.$i]	=	$phpgw->db->f('value') ;
		}
	return $dt ;
	}

//---- Cash Sale Add Initialisation

    function csnt_add_init() {
	global $ckapi,$phpgw,$pre ;

	$dt = &$ckapi[params_post][dt] ;
	$dt['transdate'] = date("Y-m-d") ;
	$dt[cashier] = $ckapi[hostsys][username];
	$dt[posnumber] = lang("[to be assigned]") ;
	$phpgw->db->query("SELECT id FROM ${pre}customer WHERE name='zzzzCash'");
	$phpgw->db->next_record();
	$dt[customer] = $phpgw->db->f('id') ;
	}

//---- Cash Sale Detail Validation Checks

    function csnt_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$err = "";
	$csrow = lang("csRow") ;
	$cserr = lang("csError:") ;
	if (input2date($dt[transdate])=="")	$err="$cserr ".lang('Invalid Cash Sale Date');
	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$csrowi = "[$csrow $i]" ;
		if ($dt['csitemid'.$i]=='')	$err="$csrowi$cserr ".lang('Item Code Missing');
		if ($dt['csqty'.$i] and !is_numeric($dt['csqty'.$i]))
					$err="$csrowi$cserr ".lang("Invalid Qty, must be numeric");
		if ($dt['csdiscount'.$i] and !is_numeric($dt['csdiscount'.$i]))
				$err="$csrowi$cserr ".lang("Invalid Discount, must be numeric");
		}
	$cstotal = $dt[cstotal] ;
	$cserrstatus = $err ;
	$aorow = lang("aoRow") ;
	$aoerr = lang("aoError:") ;
	For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
		$aorowi = "[$aorow $i]" ;
		if ($dt['aoitemid'.$i]=='')	$err="$aorowi$aoerr ".lang("Item Code Missing");
		  else	{
			$aoitemid = $dt['aoitemid'.$i] ;
			$phpgw->db->query("SELECT * FROM ${pre}addon WHERE id='$aoitemid'");
			if ($phpgw->db->next_record()) {
				$mincount = $phpgw->db->f("mincount") ;
				$maxcount = $phpgw->db->f("maxcount") ;
				$minsale = $phpgw->db->f("minsale") ;
				$maxsale = $phpgw->db->f("maxsale") ;
				}
			$count = 0 ;
			For ($j=1;isset($dt['aoitemid'.$j]);$j++) {
				if ($dt['aoitemid'.$j]==$aoitemid)	$count++ ;
				}
			if ($count<$mincount)	$err="$aoerr ".lang("Item count < Min count for").$aorowi ;
			if ($count>$maxcount)	$err="$aoerr ".lang("Item count > Max count for").$aorowi ;
			if ($cstotal<$minsale)	$err="$aoerr ".lang("Total Cash Sale < Min sale for").$aorowi;
			if ($cstotal>$maxsale)	$err="$aoerr ".lang("Total Cash Sale > Max sale for").$aorowi;
			}
		}
	if ($i==2 and $dt[aoitemid1]=='')		$err = $cserrstatus ;
	$qcrow = lang("qcRow") ;
	$qcerr = lang("qcError:") ;
	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		$qcrowi = "[$qcrow $i]" ;
		if ($dt['qcitemid'.$i]=='')	$err="$qcrowi$qcerr ".lang("Item Code Missing");
		  else	{
			if ($dt['qcqty'.$i] and !is_numeric($dt['qcqty'.$i]))
					$err="$qcrowi$qcerr ".lang("Invalid Qty, must be numeric");
			if ($dt['qcvalue'.$i] and !is_numeric($dt['qcvalue'.$i]))
				$err="$qcrowi$qcerr ".lang("Invalid Value, must be numeric");
			$qcitemid = $dt['qcitemid'.$i] ;
			$phpgw->db->query("SELECT * FROM ${pre}qcash WHERE id='$qcitemid'");
			if ($phpgw->db->next_record()) {
				$minsale = $phpgw->db->f("minsale") ;
				$maxsale = $phpgw->db->f("maxsale") ;
				$minqty = $phpgw->db->f("minqty") ;
				$maxqty = $phpgw->db->f("maxqty") ;
				$minvalue = $phpgw->db->f("minvalue") ;
				$maxvalue = $phpgw->db->f("maxvalue") ;
				}
			$qty = $value = 0 ;
			For ($j=1;isset($dt['qcitemid'.$j]);$j++) {
				if ($dt['qcitemid'.$j]==$qcitemid) {
					$qty += $dt['qcqty'.$j] ;
					$value += $dt['qcvalue'.$j] ;
					}
				}
			if ($qty<$minqty)	$err="$qcerr ".lang("Total item qty < Min qty for").$qcrowi ;
			if ($qty>$maxqty)	$err="$qcerr ".lang("Total item qty > Max qty for").$qcrowi ;
			if ($value<$minvalue) $err="$qcerr ".lang("Total item value < Min value for").$qcrowi;
			if ($value>$maxvalue) $err="$qcerr ".lang("Total item value > Max value for").$qcrowi;
			if ($cstotal<$minsale)	$err="$qcerr ".lang("Total Cash Sale < Min sale for").$qcrowi;
			if ($cstotal>$maxsale)	$err="$qcerr ".lang("Total Cash Sale > Max sale for").$qcrowi;
			}
		}
	if ($dt[totqc]<$dt[totpay])	$err="$qcerr ".lang("Total Tendered < Total Payable") ;
	if ($dt[cboxid]=="")		$err="$cserr ".lang('Cashier with no Cash Box assigned');
	if (!$err and $dt[cboxid]<>"")	{
		$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
		$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='s'" ;
		$phpgw->db->query($sql) ;
		if ($phpgw->db->num_rows()<=0)
			$err="$cserr ".lang("Cashbox start-of-shift action pending") ;
		$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
		$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
		$phpgw->db->query($sql) ;
		if ($phpgw->db->num_rows()>0)
			$err="$cserr ".lang("Cashbox closed (end-of-shift completed)") ;
		  else	{
			$phpgw->db->query("SELECT * FROM ${pre}cashbox where id='$dt[cboxid]'") ;
			$phpgw->db->next_record() ;
			$maxcash = $phpgw->db->f('maxcash') ;
			$cashbal = cashbalance($dt[cboxid],$dt[transdate],$dt[shift]) ;
			$warning = lang("Warning:") ;
			if ($cashbal>=$maxcash)	$err="$warning ".lang("Cash Full Level reached") ;
			}
		}
	If ($err)	$err = "<b><font size='+2'>$err</font></b>" ;
	if (substr_count($err,lang("csError:"))>0)	$t->set_var('csmessage',$err);
	if (substr_count($err,lang("Warning:"))>0)	{$t->set_var('csmessage',$err); $err="";}
	if (substr_count($err,lang("aoError:"))>0)	$t->set_var('aomessage',$err);
	if (substr_count($err,lang("qcError:"))>0)	$t->set_var('qcmessage',$err);

	return $err ;
	}

//---- Cash Sale Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
	$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
	$phpgw->db->query($sql) ;
	if ($phpgw->db->num_rows()>0)
		$err="$cserr ".lang("Cashbox closed (end-of-shift completed)") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Cash Sale Header

    function csnt_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$script = &$ckapi[params_post][script] ;
	$t = &$ckapi[objects][template] ;

	$taxstatus = "e" ;
	$t->set_var('lang_posnumber',lang('Cash Sale#'));
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_cashier',lang('Cashier:')." ");
	$t->set_var('lang_cashbox',lang('Cash Box'));
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_shift',lang('Shift'));
	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_taxstatus',lang('UP Tax Status'));
	$t->set_var('posnumber',$dt[posnumber]) ;
	$cashier = $dt[cashier] ;
	$transdate = $dt[transdate] ;
	$shift = $dt[shift] ;
	$duedate = $dt[duedate] ;
	$customer = $dt[customer] ;
	$cboxid = $dt[cboxid] ;
	$sql = ($cboxid) ? "SELECT * FROM ${pre}cashbox WHERE id='$cboxid'" :
				"SELECT * FROM ${pre}cashbox WHERE cashier='$cashier'" ;
	$phpgw->db->query($sql) ;
	$phpgw->db->next_record() ;
	$t->set_var('cashbox',$phpgw->db->f('name')) ;
	if (!$cboxid)	$cboxid = $phpgw->db->f('id') ;
	if (!$shift)	$shift = $phpgw->db->f('shift') ;
	if ($shift=="1")		$shift_desc = "1 - Morning" ;
	if ($shift=="2")		$shift_desc = "2 - Afternoon" ;
	if ($shift=="3")		$shift_desc = "3 - Overnight" ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('cashier',$cashier) ;
	$t->set_var('transdate',$transdate) ;
	$t->set_var('shift',$shift) ;
	$t->set_var('shift_desc',$shift_desc) ;
	$t->set_var('cboxid',$cboxid) ;
	$t->set_var('customer',$customer) ;
	$t->set_var('customer_selectlist',customer_selectlist('',$customer)) ;
	$tax_sl = "<OPTION value='e' selected>".lang('Tax Exempted')."</OPTION>" ;
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->parse('out','report',True);
	}

//---- Reformat Cash Sales Array

    function csnt_transform() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;

	$csrow_ = lang('csRow')." " ;
	$cashsale = lang('Cash Sale') ;
	$temp[id] = $dt[id] ;
	$temp[control] = $dt[control] ;
	$temp[cashier] = $dt[cashier] ;
	$temp[posnumber] = $dt[posnumber] ;
	$temp[transdate] = $dt[transdate] ;
	$temp[shift] = $dt[shift] ;
	$temp[cboxid] = $dt[cboxid] ;
	$temp[customer] = $dt[customer] ;
	$temp[taxstatus] = "e" ;

	if (isset($delete)) {$delrowno = intval(str_replace($csrow_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$csitemid = $dt['csitemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($csitemid<0)	{
			$csitemid = -$csitemid ;
			$csqty = $dt['csqty'.$i]==0 ? 1 : $dt['csqty'.$i] ;
			$phpgw->db->query("SELECT * FROM ${pre}assembly WHERE assembly_id='$csitemid'");
			while ($phpgw->db->next_record()) {
				$temp['csitemid'.$j] = $phpgw->db->f('item_id') ;
				$temp['csqty'.$j] = $phpgw->db->f('qty') * $csqty ;
				$j++ ;
				}
			continue ;
			}
		$temp['csitemid'.$j]		=	$dt['csitemid'.$i] ;
		$temp['csitemtype'.$j]		=	$dt['csitemtype'.$i] ;
		$temp['csunit'.$j]		=	$dt['csunit'.$i] ;
		$temp['csqty'.$j]		=	$dt['csqty'.$i] ;
		$temp['csprice'.$j]		=	$dt['csprice'.$i] ;
		$temp['csdiscount'.$j]		=	$dt['csdiscount'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$cashsale ;
	if (substr_count($newrow,$cashsale)>0)		$temp['csitemid'.$j] = "" ;

	For ($i=1;isset($dt['aoitemid'.$i]);$i++)	$temp['aoitemid'.$i]=$dt['aoitemid'.$i] ;

	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		$temp['qcitemid'.$i]		=	$dt['qcitemid'.$i] ;
		$temp['qcqty'.$i]		=	$dt['qcqty'.$i] ;
		$temp['qcvalue'.$i]		=	$dt['qcvalue'.$i] ;
		}

	$dt = $temp ;
	unset($temp) ;
	}

//---- Write Cash Sale Detail

    function csnt_detail_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$firstime = $ckapi[params_post][firstime] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$csrow_ = lang('csRow')." " ;
	$cashsale = lang('Cash Sale') ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$taxstatus = "e" ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_csale',lang('Cash Sale Items :'));
	$t->set_var('lang_number',lang('Item Code - Id'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_discount',lang('Discount')."<br>$");
	$t->set_var('lang_price',lang('Unit Price'));
	$t->set_var('lang_itemtotal',lang('Item Total'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_csnewrow',lang('Add New')." $cashsale ".lang('Item Row'));
	$item_sl = item_selectlist("",'') ;

	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$t->set_var('itemid_fld','csitemid'.$i) ;
		$t->set_var('qty_fld','csqty'.$i);
		$t->set_var('discount_fld','csdiscount'.$i);
		$csitemid = $dt['csitemid'.$i] ;
		$t->set_var('csitemid',$csitemid) ;
		$t->set_var('item_selectlist',str_replace("'$csitemid'","'$csitemid'"." selected",$item_sl));
		$csitemtype = $dt['csitemtype'.$i] ;
		$csunit = $dt['csunit'.$i] ;
		$csqty = ($csitemid<>'' and $dt['csqty'.$i]=='') ? 1 : $dt['csqty'.$i] ;
		$csdiscount = $dt['csdiscount'.$i] ;
		$csprice = $dt['csprice'.$i] ;
		unset($itemid) ;
		$csitemid = ($csitemid=="") ? 0 : $csitemid ;
		$phpgw->db->query("SELECT * FROM ${pre}sprice WHERE id='$csitemid'") ;
		if ($phpgw->db->next_record()) {
			$itemid = $dt['itemid'.$i] = $phpgw->db->f('itemid') ;
			$name = $phpgw->db->f('name') ;
			$price = $phpgw->db->f('price') ;
			}
		$item_id = ($itemid) ? $itemid : $csitemid ;
		$phpgw->db->query("SELECT * FROM ${pre}service WHERE id='$item_id'") ;
		if ($phpgw->db->next_record()) {
			$type = "s" ;
			$desc = $phpgw->db->f('description') ;
			$unit = $phpgw->db->f('unit') ;
			$dt['csincaccid'.$i] =  $phpgw->db->f('income_accno_id') ;
			if (!$itemid)	$price = $phpgw->db->f('price') ;
			}
		     else {
			$phpgw->db->query("SELECT * FROM ${pre}parts WHERE id='$item_id'");
			$phpgw->db->next_record() ;
			$type = "i" ;
			$desc = $phpgw->db->f('description') ;
			$unit = $phpgw->db->f('unit') ;
			$dt['cscost'.$i] = $phpgw->db->f('cost') ;
			$dt['csinvaccid'.$i] =  $phpgw->db->f('inventory_accno_id') ;
			$dt['csincaccid'.$i] =  $phpgw->db->f('income_accno_id') ;
			$dt['csexpaccid'.$i] =  $phpgw->db->f('expense_accno_id') ;
			if (!$itemid)	$price = $phpgw->db->f('price') ;
			}
		$description = ($itemid) ? $name." -- Special -- ".$desc : $desc ;
		$csitemtype = $dt['csitemtype'.$i] = $type;
		$csunit = $dt['csunit'.$i] = $unit ;
		$csprice = $dt['csprice'.$i] = $price ;
		$t->set_var('itemtype',$csitemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$csunit);
		$t->set_var('qty',$csqty);
		$t->set_var('discount',$csdiscount);
		$t->set_var('price',$csprice);
		$itemtotal = $dt['csitemtotal'.$i] = number_format($csqty*$csprice-$csdiscount,2,".",'') ;
		$cstotal += $itemtotal ;
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('rowno',$csrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);

		$dt['csitemid'.$i] = $csitemid ;
		$dt['csitemtype'.$i] = $csitemtype ;
		$dt['csqty'.$i] = $csqty ;
		$dt['csprice'.$i] = $csprice ;
		$dt['csdiscount'.$i] = $csdiscount ;
		$dt['csunit'.$i] = $csunit ;
		}

	$t->set_var('lang_cstotal',lang('Total Cash Sale'));
	$dt[cstotal] = number_format($cstotal,2,".",'') ;
	$t->set_var('cstotal',$dt[cstotal]) ;
	$this->csnt_addon_write();
	$this->csnt_qcash_write();
	}

//---- Write Cash Sale AddOn Items

    function csnt_addon_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_block('report','addon','addon_section');
	if ($op=="view" or $op=="delete")	$posted = True ;
	$aorow_ = lang('aoRow')." " ;
	$addon = lang('AddOn') ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_addon',lang('Add On Charge/Reduction Items :'));
	$t->set_var('lang_addonnumber',lang('AddOn Name - Id'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_factor',lang('% of CS'));
	$t->set_var('lang_aoamount',lang('Amount'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_aonewrow',lang('Add New')." $addon ".lang('Item Row'));
	if (isset($delete))	$delrowno = intval(str_replace($aorow_,"",$delete));
	if ($delrowno==0)	unset($delete) ;
	$addon_sl = addon_selectlist("",'') ;
	$totpay = $cstotal = $dt[cstotal] ;
	For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if (isset($delete) and $i>$delrowno) {$j=$i-1;} else {$j=$i;}
		$t->set_var('itemid_fld','aoitemid'.$j) ;
		$itemid = $dt['aoitemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('addon_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$addon_sl));
		$itemid = ($itemid=="") ? 0 : $itemid ;
		$phpgw->db->query("SELECT * FROM ${pre}addon WHERE id='$itemid'") ;
		$phpgw->db->next_record() ;
		$notes = $phpgw->db->f('notes') ;
		$pos = strpos($notes,"--log--") ;
		$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
		$factor = $dt['aofactor'.$i] = $phpgw->db->f('factor') ;
		$dt['aoincaccid'.$i] = $phpgw->db->f('incacc_id') ;
		$dt['aoexpaccid'.$i] = $phpgw->db->f('expacc_id') ;
		$aoamount = $dt['aoamount'.$i] = number_format($cstotal*$factor,2,".",'') ;
		$t->set_var('notes',$notes);
		$t->set_var('factor',$factor*100);
		$t->set_var('aoamount',$aoamount);
		$totpay += $aoamount ;
		$t->set_var('rowno',$aorow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('addon_section','addon', True);
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$addon ;
	if (substr_count($newrow,$addon)>0) {
		$t->set_var('itemid_fld','aoitemid'.$i) ;
		$t->set_var('addon_selectlist',$addon_sl);
		$t->set_var('notes',"");
		$t->set_var('factor',"");
		$t->set_var('aoamount',"");
		$t->set_var('rowno',$aorow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('addon_section','addon', True);
		}
	$t->set_var('lang_totpay',lang('Total Payable'));
	$t->set_var('totpay',number_format($totpay,2,".",'')) ;
	$dt[totpay] = $totpay ;
	}

//---- Write Cash Sale Payment / Quasi Cash Items

    function csnt_qcash_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_block('report','qcash','qcash_section');
	if ($op=="view" or $op=="delete")	$posted = True ;
	$qcrow_ = lang('qcRow')." " ;
	$qcash = lang('QCash') ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_qcash',lang('Payment / Quasi-Cash Tendered :'));
	$t->set_var('lang_qcashnumber',lang('QCash Name - Id'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_value',lang('Value'));
	$t->set_var('lang_qcamount',lang('Amount'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_qcnewrow',lang('Add New')." $qcash ".lang('Row'));
	if (isset($delete))	$delrowno = intval(str_replace($qcrow_,"",$delete));
	if ($delrowno==0)	unset($delete) ;
	$qcash_sl = qcash_selectlist("",'') ;
	$totpay = $dt[totpay] ;
	$totqc = 0 ;
	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if (isset($delete) and $i>$delrowno) {$j=$i-1;} else {$j=$i;}
		$t->set_var('itemid_fld','qcitemid'.$j) ;
		$t->set_var('qty_fld','qcqty'.$j);
		$t->set_var('value_fld','qcvalue'.$j);
		$itemid = $dt['qcitemid'.$i] ;
		$t->set_var('itemid',$qcitemid) ;
		$t->set_var('qcash_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$qcash_sl));
		$itemid = ($itemid=="") ? 0 : $itemid ;
		$phpgw->db->query("SELECT * FROM ${pre}qcash WHERE id='$itemid'") ;
		$phpgw->db->next_record() ;
		$notes = $phpgw->db->f('notes') ;
		$pos = strpos($notes,"--log--") ;
		$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
		$dt['qcposaccid'.$i] = $phpgw->db->f('posacc_id') ;
		$qcqty = $dt['qcqty'.$i]<>'' ? $dt['qcqty'.$i]: 1;
		$faceval = $phpgw->db->f('value') ;
		$value = $dt['qcvalue'.$i] = ($faceval<>'' and $faceval<>0) ? $faceval : $dt['qcvalue'.$i] ;
		$qcamount = $dt['qcamount'.$i] = number_format($qcqty*$value,2,".",'') ;
		$t->set_var('notes',$notes);
		$t->set_var('qty',$qcqty);
		$t->set_var('value',$value);
		$t->set_var('qcamount',$qcamount);
		$totqc += $qcamount ;
		$t->set_var('rowno',$qcrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('qcash_section','qcash', True);
		}

	$lasti = $i-1 ;
	$dt['qcqty'.$lasti] = $qcqty ;

	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$qcash ;
	if (substr_count($newrow,$qcash)>0) {
		$t->set_var('itemid_fld','qcitemid'.$i) ;
		$t->set_var('qcash_selectlist',$qcash_sl);
		$t->set_var('qty_fld','qcqty'.$i);
		$t->set_var('value_fld','qcvalue'.$i);
		$t->set_var('notes',"");
		$t->set_var('qty',"");
		$t->set_var('value',"");
		$t->set_var('qcamount',"");
		$t->set_var('rowno',$qcrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('qcash_section','qcash', True);
		}
	$t->set_var('lang_totqc',lang('Total'));
	$t->set_var('totqc',number_format($totqc,2,".",'')) ;
	$t->set_var('lang_change',lang('Change'));
	$dt[totqc] = $totqc ;
	$qcchange = $dt[qcchange] = number_format($totqc-$totpay,2,".",'') ;
	$t->set_var('change',$qcchange) ;
	$lang_cash = lang('Cash') ;
	$phpgw->db->query("SELECT * FROM ${pre}qcash WHERE name='$lang_cash'") ;
	$phpgw->db->next_record() ;
	$dt[cashaccid] = $phpgw->db->f('posacc_id') ;
	}

//---- Cash Sale Post Initialisation

    function csnt_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$op = &$ckapi[params_post][op] ;

	$user = $ckapi[hostsys][username];
	$dt[posnumber] = ($op=='edit') ? $dt[posnumber] : "$user:".date("Ymd:His") ;
	$dt[source]	= "CSNT" ;
	$desc = lang('Cash Sale') ;
	$dt[description] = "CS: $desc# $dt[posnumber]" ;
	$dt[amount] = $dt[netamount] = $dt[totpay] ;
	}

//---- Cash Sale Post - PreCommit Routine

    function csnt_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;
	$transdate = $dt['transdate'] ;

	if ($op<>'new')	{
		$phpgw->db->query("DELETE from ${pre}positem where trans_id=$id");
		$phpgw->db->query("DELETE from ${pre}acc_trans where trans_id=$id");
		$phpgw->db->query("DELETE from ${pre}il where id=$id");
		$phpgw->db->query("DELETE from ${pre}inv_trans where trans_id=$id");
		}

	if ($op<>'delete') {
		$invitem = False ;
		For ($i=1;isset($dt['csitemid'.$i]);$i++) {
			$csitemid	= $dt['csitemid'.$i];
			$csitemtype	= $dt['csitemtype'.$i];
			$csunit		= $dt['csunit'.$i];
			$csqty		= $dt['csqty'.$i];
			$csprice	= $dt['csprice'.$i];
			$csdiscount	= $dt['csdiscount'.$i];
			$itemtotal	= $dt['csitemtotal'.$i] ;
			$cost		= $dt['cscost'.$i] ;
			$invaccid	= $dt['csinvaccid'.$i] ;
			$incaccid	= $dt['csincaccid'.$i] ;
			$expaccid	= $dt['csexpaccid'.$i] ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$incaccid','$itemtotal','$transdate')";
			$phpgw->db->query($sql);
			if ($csitemtype=="i" and $cost<>0 and $cost<>'') {
				$cogs = number_format($csqty*$cost,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$expaccid','-$cogs','$transdate')";
				$phpgw->db->query($sql);
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$invaccid','$cogs','$transdate')";
				$phpgw->db->query($sql);
				$sql="INSERT INTO ${pre}inv_trans (trans_id,order_id,parts_id,qty,transdate)";
				$sql.= " VALUES ('$id','$id','$csitemid','-$csqty','$transdate')" ;
				$phpgw->db->query($sql);
				$invitem = True ;
				}
			$invaccid = ($invaccid=="") ? 0 : $invaccid ;
			$incaccid = ($incaccid=="") ? 0 : $incaccid ;
			$expaccid = ($expaccid=="") ? 0 : $expaccid ;
			$sql = "INSERT INTO ${pre}positem (trans_id,invacc_id,incacc_id,expacc_id,itemid," ;
			$sql.= "itemtype,qty,price,cost,discount,unit) " ;
			$sql.= "VALUES ('$id','$invaccid','$incaccid','$expaccid','$csitemid'," ;
			$sql.= "'$csitemtype','$csqty','$csprice','$cost','$csdiscount','$csunit')";
			$phpgw->db->query($sql);
			}
		if ($invitem == True) {
			$ildesc1 = lang('GD against CS') ;
			$ildesc = "CS: $ildesc1# $dt[posnumber]" ;
			$sql = "INSERT INTO ${pre}il (id,source,description,to_from,transdate) " ;
			$sql.= "VALUES ('$id','$dt[source]','$ildesc','$dt[customer]','$transdate') " ;
			$phpgw->db->query($sql) ;
			}
		For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
			$aoitemid = $dt['aoitemid'.$i] ;
			if ($aoitemid=="")	continue ;
			$aofactor = $dt['aofactor'.$i] ;
			$aoamount = $dt['aoamount'.$i] ;
			$aoincaccid = $dt['aoincaccid'.$i] ;
			$aoexpaccid = $dt['aoexpaccid'.$i] ;
			$chartid = ($aoamount>0) ? $aoincaccid : $aoexpaccid ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$chartid','$aoamount','$transdate')";
			$phpgw->db->query($sql);
			$sql = "INSERT INTO ${pre}positem (trans_id,incacc_id,expacc_id," ;
			$sql.= "itemid,itemtype,value,factor) " ;
			$sql.= "VALUES ('$id','$aoincaccid','$aoexpaccid'," ;
			$sql.= "'$aoitemid','a','$dt[cstotal]','$aofactor')";
			$phpgw->db->query($sql);
			}
		For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
			$qcitemid = $dt['qcitemid'.$i] ;
			$qcqty = $dt['qcqty'.$i] ;
			$qcvalue = $dt['qcvalue'.$i] ;
			$qcamount = $dt['qcamount'.$i] ;
			$qcposaccid = $dt['qcposaccid'.$i] ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$qcposaccid','-$qcamount','$transdate')";
			$phpgw->db->query($sql);
			$sql = "INSERT INTO ${pre}positem(trans_id,posacc_id,itemid,itemtype,qty,value) ";
			$sql.= "VALUES ('$id','$qcposaccid','$qcitemid','q','$qcqty','$qcvalue')";
			$phpgw->db->query($sql);
			}
		if ($dt[qcchange]<>0) {
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$dt[cashaccid]','$dt[qcchange]','$transdate')";
			$phpgw->db->query($sql);
			$sql = "INSERT INTO ${pre}positem(trans_id,posacc_id,itemid,itemtype,qty,value) ";
			$sql.= "VALUES ('$id','$dt[cashaccid]',0,'c','1','-$dt[qcchange]')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>
