<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: functions.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

// This is loaded by default

    function init() {
	}

//---- Set Up Tax/Number Select Option List

    function tax_selectlist($filter,$default) {
	global $phpgw,$pre ;

	$phpgw->db->query("SELECT * FROM ${pre}tax $filter ORDER BY taxnumber");
	$selectlist = "<OPTION value=''>".lang('No Tax')."</OPTION>" ;
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$rate = $phpgw->db->f('rate')*100;
		$taxnumber = $phpgw->db->f('taxnumber');
		$selectlist .= "<OPTION value='$id'>$rate% $taxnumber -- $id</OPTION>" ;
		} 
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}


//---- Set Up Customer Name/Number Select Option List

    function customer_selectlist($filter,$default) {
	global $phpgw,$pre ;

	$phpgw->db->query("SELECT id, name FROM ${pre}customer $filter ORDER BY name");
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$name = $phpgw->db->f('name');
		$selectlist .= "<OPTION value='$id'>$name -- $id</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Currency ISOcode Select Option List

   function isocode_selectlist($filter,$default) {
	global $phpgw,$pre ;

	$sql="SELECT * FROM ${pre}currency $filter ORDER BY isocode" ;
	$phpgw->db->query($sql);
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$isocode = $phpgw->db->f('isocode');
		$description = $phpgw->db->f('description');
		$selectlist .= "<OPTION value='$isocode'>$isocode -- $description</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Account Number Select Option List

    function account_selectlist($filter,$default) {
	global $phpgw,$pre ;

	$sql="SELECT id, accno,description FROM ${pre}chart $filter ORDER BY accno" ;
	$phpgw->db->query($sql);
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$accno = $phpgw->db->f('accno');
		$description = substr($phpgw->db->f('description'),0,20);
		$selectlist .= "<OPTION value='$id'>$accno -- $description</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Item Code Select Option List

    function item_selectlist($filter,$default) {
	global $phpgw,$pre ;

	$selectlist .='<OPTION value=""></OPTION><OPTION value="">'.lang('Product/Parts :').'</OPTION>';
	$phpgw->db->query("SELECT id,partnumber FROM ${pre}parts $filter ORDER BY partnumber");
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$partnumber = $phpgw->db->f('partnumber');
		$selectlist .= "<OPTION value='$id'>$partnumber -- $id</OPTION>" ;
		}
	$selectlist .= '<OPTION value=""></OPTION><OPTION value="">'.lang('Services :').'</OPTION>';
	$phpgw->db->query("SELECT id,servicenumber FROM ${pre}service $filter ORDER BY servicenumber");
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$servicenumber = $phpgw->db->f('servicenumber');
		$selectlist .= "<OPTION value='$id'>$servicenumber -- $id</OPTION>" ;
		}
	$selectlist .= '<OPTION value=""></OPTION>' ;
	$selectlist .= '<OPTION value="">'.lang('Assembly/Package').'</OPTION>' ;
	$selectlist .= '<OPTION value="">'.lang('(to explode):').'</OPTION>';
	$phpgw->db->query("SELECT distinct a.assembly_id,partnumber FROM ${pre}assembly a, ${pre}parts b WHERE a.assembly_id=b.id ORDER BY partnumber");
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('assembly_id') ;
		$partnumber = $phpgw->db->f('partnumber');
		$selectlist .= "<OPTION value='-$id'>$partnumber -- $id</OPTION>" ;
		}
	$phpgw->db->query("SELECT distinct a.assembly_id,servicenumber FROM ${pre}assembly a, ${pre}service b WHERE a.assembly_id=b.id ORDER BY servicenumber");
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('assembly_id') ;
		$servicenumber = $phpgw->db->f('servicenumber');
		$selectlist .= "<OPTION value='-$id'>$servicenumber -- $id</OPTION>" ;
		}
	if ($default<>'')	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Quotation Name/Number Select Option List

    function quote_selectlist($filter,$default) {
	global $phpgw,$pre ;

	$phpgw->db->query("SELECT id, quotenumber FROM ${pre}quote $filter ORDER BY quotenumber");
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$number = $phpgw->db->f('quotenumber');
		$selectlist .= "<OPTION value='$id'>$number -- $id</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

//---- This function, input2date($idate), is made to check date-input from an HTML-form
 //--- and bring it to the YYYY-MM-DD format that it can be
 //--- insertet in a Date-Field of a MySQL-Table.
 //
 //--- Input-Formats can be:
 //--- "d.m.y" or "y.m.d" or "d.m" or "d"
 //--- if year or month and year are missing, these values are
 //--- taken from the current date.
 //
 //--- When the result-String is empty, the date-input was wrong.
 //
 //--- Usage: $date_ok = input2date($date_from_form_field);
 //

 function input2date($idate)
 {
   $token= "-./ ";

   $p1 = strtok($idate,$token);
   $p2 = strtok($token);
   $p3 = strtok($token);
   $p4 = strtok($token);

   $date= "";
   $y= ""; $m= ""; $d= "";

    // check 'd.m.y'
   if (($p1>0 && $p1<32) &&
       ($p2>0 && $p2<13) &&
       ($p3>32))
   {
     $y=$p3;
     $m=$p2;
     $d=$p1;
   }

    // check 'y.m.d'
   if ($y ==  "" &&
       ($p1>32) &&
       ($p2>0 && $p2<13) &&
       ($p3>0 && $p3<32))
   {
     $y=$p1;
     $m=$p2;
     $d=$p3;
   }

    // check 'd.m'
   if ($y ==  "" &&
       ($p3== "") &&
       ($p2>0 && $p2<13) &&
       ($p1>0 && $p1<32))
   {
     $y=date( "Y");
     $m=$p2;
     $d=$p1;
   }

    // check 'd'
   if ($y ==  "" &&
       ($p3== "") &&
       ($p2== "") &&
       ($p1>0 && $p1<32))
   {
     $y=date( "Y");
     $m=date( "m");
     $d=$p1;
   }

    // add 1900 or 2000 to year
   if ($y!= "" && $y<=99)
   {
     if ($y>=70) $y = $y + 1900;
     if ($y<70) $y = $y + 2000;
   }

   if ($y!= "")
   {
     if (checkdate($m, $d, $y))
       $date= "$y-$m-$d";
   }

   return $date;
 }

    init();

?>
